/*
 * blanco Framework
 * Copyright (C) 2004-2005 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.resourcebundle;

import java.io.File;
import java.text.Format;
import java.util.ArrayList;
import java.util.HashMap;

import javax.xml.transform.dom.DOMResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import blanco.commons.util.BlancoBigDecimalUtil;
import blanco.commons.util.BlancoJavaSourceUtil;
import blanco.commons.util.BlancoStringUtil;
import blanco.commons.util.BlancoXmlUtil;
import blanco.resourcebundle.expand.BlancoResourceBundleExpandResourceBundle;
import blanco.resourcebundle.resourcebundle.BlancoResourceBundleResourceBundle;

/**
 * W̒XMLt@C̓eÓ`FbNs܂B
 * 
 * ̃\[XR[hblancoResourceBundlëꕔłB<br>
 * 
 * @author IGA Tosiki
 */
public class BlancoResourceBundleXmlValidator {
    /**
     * \[XohANZT̃CX^XB
     */
    private final BlancoResourceBundleResourceBundle bundle = new BlancoResourceBundleResourceBundle();

    /**
     * \[XohMessageFormatɂp[XsۂɁAO珈𒆒f邩ǂ̃tOB
     * 
     * trueȂ珈fėO𔭐܂B<br>
     * falseȂ珈sAû͖Ƃ݂Ȃ܂B<br>
     * Javã\[XR[hۂȂǂɁA falseɐݒ肵ĔgʂƂł悤ɐ؂ւꍇ܂B<br>
     * ftHgl[true]ݒ肳Ă܂B
     */
    private boolean fIsFailOnMessageFormatError = true;

    /**
     * \[XohMessageFormatɂp[XsۂɁAO珈𒆒f邩ǂ̃tOݒ肵܂B
     * 
     * trueȂ珈fėO𔭐܂B<br>
     * falseȂ珈sAû͖Ƃ݂Ȃ܂B<br>
     * Javã\[XR[hۂȂǂɁA falseɐݒ肵ĔgʂƂł悤ɐ؂ւꍇ܂B<br>
     * ftHgl[true]ݒ肳Ă܂B
     * 
     * @param isFailOnMessageFormatError
     */
    public void setFailOnMessageFormatError(
            final boolean isFailOnMessageFormatError) {
        fIsFailOnMessageFormatError = isFailOnMessageFormatError;
    }

    /**
     * XMLt@C vpeBt@CANZXpJava\[XR[h𐶐܂B
     * 
     * @param fileSource
     *            ͂ƂȂ钆XMLt@CB
     * @param directoryTarget
     *            \[XR[ho͂ۂ̏o͐fBNgB
     */
    public void process(final File fileSource, final File directoryTarget) {
        final DOMResult result = BlancoXmlUtil.transformFile2Dom(fileSource);

        final Node rootNode = result.getNode();
        if (rootNode instanceof Document) {
            // ꂪnBhLg[g擾
            final Document rootDocument = (Document) rootNode;
            final NodeList listSheet = rootDocument
                    .getElementsByTagName("sheet");
            final int sizeListSheet = listSheet.getLength();
            final HashMap mapProcessedBaseName = new HashMap(64);
            for (int index = 0; index < sizeListSheet; index++) {
                final Element elementSheet = (Element) listSheet.item(index);

                final NodeList listCommon = elementSheet
                        .getElementsByTagName("blancoresourcebundle-common");
                if (listCommon == null || listCommon.getLength() == 0) {
                    // commonꍇɂ̓XLbv܂B
                    continue;
                }

                final Element elementCommon = (Element) listCommon.item(0);
                final String baseName = BlancoXmlUtil.getTextContent(
                        elementCommon, BlancoResourceBundleConstants.BASE_NAME);
                if (baseName == null) {
                    continue;
                }

                if (BlancoXmlUtil.getTextContent(elementCommon,
                        BlancoResourceBundleConstants.PACKAGE_NAME) == null) {
                    continue;
                }

                final ArrayList listLocale = new ArrayList();
                final NodeList nodeListCommon = elementCommon
                        .getElementsByTagName(BlancoResourceBundleConstants.LOCALE);
                if (nodeListCommon == null || nodeListCommon.getLength() == 0) {
                    continue;
                }

                final int sizeNodeListCommon = nodeListCommon.getLength();
                for (int indexLocale = 0; indexLocale < sizeNodeListCommon; indexLocale++) {
                    final Node nodeLook = nodeListCommon.item(indexLocale);
                    if (nodeLook instanceof Element == false) {
                        continue;
                    }

                    final Element elementLook = (Element) nodeLook;
                    final NodeList nodeChilds = elementLook.getChildNodes();
                    if (nodeChilds == null) {
                        continue;
                    }

                    final int nodeChildsLength = nodeChilds.getLength();
                    for (int indexChild = 0; indexChild < nodeChildsLength; indexChild++) {
                        final Node nodeChild = nodeChilds.item(indexChild);
                        if (nodeChild instanceof Text) {
                            listLocale.add(((Text) nodeChild).getNodeValue());
                        }
                    }
                }
                if (listLocale.size() == 0) {
                    continue;
                }

                if (mapProcessedBaseName.get(baseName) != null) {
                    throw new IllegalArgumentException(
                            bundle
                                    .getXmlValidatorErr001(baseName,
                                            (String) mapProcessedBaseName
                                                    .get(baseName)));
                }

                expandSheet(elementSheet, elementCommon);
                mapProcessedBaseName.put(baseName, "܂");
            }
        }
    }

    /**
     * W̒XMLt@C̓eÓ`FbNs܂B
     * 
     * @param elementSheet
     *            V[g̃GgB
     * @param elementCommon
     *            ʏ̃GgB
     */
    private void expandSheet(final Element elementSheet,
            final Element elementCommon) {
        final String baseName = BlancoXmlUtil.getTextContent(elementCommon,
                BlancoResourceBundleConstants.BASE_NAME);
        final String packageName = BlancoXmlUtil.getTextContent(elementCommon,
                BlancoResourceBundleConstants.PACKAGE_NAME);
        final String suffix = BlancoXmlUtil.getTextContent(elementCommon,
                BlancoResourceBundleConstants.SUFFIX);
        final String description = BlancoXmlUtil.getTextContent(elementCommon,
                BlancoResourceBundleConstants.DESCRIPTION);

        final ArrayList listKnownLocale = new ArrayList();
        final HashMap mapBundle = new HashMap();
        // ^ꂽpbP[Ŵ܂ܗp܂B

        final NodeList listCommonList = elementSheet
                .getElementsByTagName("blancoresourcebundle-common");
        if (listCommonList == null || listCommonList.getLength() == 0) {
            // commonꍇɂ̓XLbv܂B
            return;
        }

        checkLocaleDup(baseName, description, listKnownLocale, listCommonList);

        final NodeList listResourceList = elementSheet
                .getElementsByTagName("blancoresourcebundle-resourceList");
        if (listResourceList == null || listResourceList.getLength() == 0) {
            // {̂̕ɂĂ͏XLbv܂B
            return;
        }

        final NodeList listResource = ((Element) listResourceList.item(0))
                .getElementsByTagName("resource");
        if (listResource == null || listResource.getLength() == 0) {
            return;
        }

        final int sizeListResource = listResource.getLength();
        for (int indexResource = 0; indexResource < sizeListResource; indexResource++) {
            final Element elementResource = (Element) listResource
                    .item(indexResource);

            final String fieldResourceId = BlancoStringUtil
                    .null2Blank(BlancoXmlUtil.getTextContent(elementResource,
                            BlancoResourceBundleConstants.RESOURCE_KEY));

            final NodeList nodeListResourceString = elementResource
                    .getElementsByTagName(BlancoResourceBundleConstants.RESOURCE_STRING);
            if (nodeListResourceString == null
                    || nodeListResourceString.getLength() == 0) {
                // ꌏꍇɂ̓XLbv܂B
                continue;
            }

            checkMessageFormat(baseName, description, mapBundle,
                    fieldResourceId, nodeListResourceString,
                    fIsFailOnMessageFormatError);
        }
    }

    /**
     * P[̏d݂Ȃǂ`FbN܂B
     * 
     * @param baseName
     * @param description
     * @param listKnownLocale
     * @param listCommonList
     */
    private void checkLocaleDup(final String baseName,
            final String description, final ArrayList listKnownLocale,
            final NodeList listCommonList) {
        // P[̏d`FbNs܂B
        final NodeList listLocale = ((Element) listCommonList.item(0))
                .getElementsByTagName("locale");
        if (listLocale == null || listLocale.getLength() == 0) {
            return;
        }

        final int sizeListLocale = listLocale.getLength();
        if (sizeListLocale > 0) {
            final HashMap mapExistLocale = new HashMap();
            for (int indexLocale = 0; indexLocale < sizeListLocale; indexLocale++) {
                final Element elementLocale = (Element) listLocale
                        .item(indexLocale);
                final String locale = BlancoStringUtil.null2Blank(BlancoXmlUtil
                        .getTextContent(elementLocale));
                if (mapExistLocale.get(locale) != null) {
                    // P[̏d܂B
                    throw new IllegalArgumentException(bundle
                            .getXmlValidatorErr002(baseName
                                    + (description == null ? "" : "/"
                                            + description), locale));
                }
                listKnownLocale.add(locale);
                mapExistLocale.put(locale, locale);
            }
        }
    }

    /**
     * bZ[WtH[}bg̃p[XʂP[ԂɂđÓȏԂł邩ǂ`FbN܂B
     * 
     * P[ԂőႪꍇɂ͗Oŏf܂B
     * 
     * @param baseName
     *            B
     * @param description
     *            BOɗp܂B
     * @param mapBundle
     * @param fieldResourceId
     *            \[XIDB
     * @param nodeListResourceString
     * @param isFailOnMessageFormatError
     *            MessageFormatɂp[X̌ʂƂėOꍇɏf邩ǂB
     */
    private void checkMessageFormat(final String baseName,
            final String description, final HashMap mapBundle,
            final String fieldResourceId,
            final NodeList nodeListResourceString,
            final boolean isFailOnMessageFormatError) {
        final HashMap mapProcessedLocale = new HashMap();
        Format[] previousFormatList = null;

        final int nodeListResourceStringSize = nodeListResourceString
                .getLength();
        for (int indexResourceString = 0; indexResourceString < nodeListResourceStringSize; indexResourceString++) {
            if (nodeListResourceString.item(indexResourceString) instanceof Element == false) {
                continue;
            }

            final Element elementResourceString = (Element) nodeListResourceString
                    .item(indexResourceString);
            final String resourceString = BlancoStringUtil
                    .null2Blank(BlancoXmlUtil
                            .getTextContent(elementResourceString));
            final String locale = BlancoStringUtil
                    .null2Blank(elementResourceString.getAttribute("locale"));
            if (mapProcessedLocale.get(locale) != null) {
                // ɏς̃P[ł΃\[XIDdĂG[łƔf܂B
                throw new IllegalArgumentException(bundle
                        .getXmlValidatorErr003(
                                baseName
                                        + (description == null ? "" : "/"
                                                + description), locale,
                                fieldResourceId));
            }

            // VɏΏۂƂ郍P[ƂċL܂B
            mapProcessedLocale.put(locale, locale);
            if (mapBundle.get(fieldResourceId) == null) {
                // \[Xoh̃}bvɋL܂B
                mapBundle.put(fieldResourceId, resourceString);
            }

            Format[] formatList = null;
            try {
                formatList = BlancoResourceBundleExpandResourceBundle
                        .getFormatsByArgumentIndex(resourceString,
                                isFailOnMessageFormatError);
            } catch (IllegalArgumentException ex) {
                throw new IllegalArgumentException(
                        bundle
                                .getXmlValidatorErr004(
                                        baseName,
                                        locale,
                                        fieldResourceId,
                                        BlancoJavaSourceUtil
                                                .escapeStringAsJavaSource(resourceString))
                                + ex.toString());
            }

            if (indexResourceString == 0) {
                // ͔rs܂B
            } else {
                if (previousFormatList == null && formatList == null) {
                    // vĂ܂B肠܂B
                } else if (previousFormatList == null && formatList != null) {
                    throw new IllegalArgumentException(bundle
                            .getXmlValidatorErr005(baseName
                                    + (description == null ? "" : "/"
                                            + description), locale,
                                    fieldResourceId, BlancoBigDecimalUtil
                                            .toBigDecimal(formatList.length)));
                } else if (previousFormatList != null && formatList == null) {
                    throw new IllegalArgumentException(
                            bundle
                                    .getXmlValidatorErr006(
                                            baseName
                                                    + (description == null ? ""
                                                            : "/" + description),
                                            locale,
                                            fieldResourceId,
                                            BlancoBigDecimalUtil
                                                    .toBigDecimal(previousFormatList.length)));
                } else {
                    if (previousFormatList.length != formatList.length) {
                        throw new IllegalArgumentException(
                                bundle
                                        .getXmlValidatorErr007(
                                                baseName
                                                        + (description == null ? ""
                                                                : "/"
                                                                        + description),
                                                locale,
                                                fieldResourceId,
                                                BlancoBigDecimalUtil
                                                        .toBigDecimal(formatList.length),
                                                BlancoBigDecimalUtil
                                                        .toBigDecimal(previousFormatList.length)));
                    }
                    for (int indexFormat = 0; indexFormat < formatList.length; indexFormat++) {
                        final String previousFormatClass = (previousFormatList[indexFormat] == null ? bundle
                                .getExpandresourceSrc051()
                                : previousFormatList[indexFormat].getClass()
                                        .getName());
                        final String formatClass = (formatList[indexFormat] == null ? bundle
                                .getExpandresourceSrc051()
                                : formatList[indexFormat].getClass().getName());
                        if (formatClass.equals(previousFormatClass) == false) {
                            throw new IllegalArgumentException(bundle
                                    .getExpandresourceErr007(baseName
                                            + (description == null ? "" : "/"
                                                    + description), locale,
                                            fieldResourceId, formatClass,
                                            previousFormatClass));
                        }
                    }
                }
            }
            // ÕXgƂċL܂B
            // null낤낤L_|CgłB
            previousFormatList = formatList;
        }
    }
}